# -*- coding: utf-8 -*-
"""
Created on Fri Feb  2 17:55:50 2024

@author: vdbri
"""


Database

    def calculate_Pdef_cum(self, name='Pdef',
                           tsdicP={'dtype': 'P', 'dbase': 'knmiBH'},
                           tsdicETp={'dtype': 'ETp', 'dbase': 'knmiBH'},
                           month_start=4,
                           month_end=10):
        '''Cala'''
        Pdef = pd.Series(dtype=float)
        for year in range(2010, 2023):
            begin = pd.Timestamp(year=year, month=month_start, day=1)
            end = pd.Timestamp(year=year+int(month_end/12),
                               month=month_end % 12 + 1, day=1)
            end = end - pd.Timedelta(1, unit='s')
            trange = [begin, end]
            P = self.get_timeseries(tsdicP).get_data(resample={'method': 'sum',
                                                               'scale': '1D'},
                                                     period=trange)
            ETp = self.get_timeseries(tsdicETp).get_data(resample={'method': 'sum',
                                                                   'scale': '1D'},
                                                         period=trange)
            Pdef_year = (P - ETp).cumsum()
            Pdef_year.loc[end] = np.nan
            Pdef = pd.concat([Pdef, Pdef_year])
        tsPdef = Timeseries(name, Pdef)
        self.add_timeseries(tsPdef)

    def calculate_Pdef_window(self, name='Pdef',
                               window=3,
                               tsdicP={'dtype': 'P', 'dbase': 'knmiBH'},
                               tsdicETp={'dtype': 'ETp', 'dbase': 'knmiBH'},
                               month_start=4,
                               month_end=10):
        Pdef = pd.Series(dtype=float)
        for year in range(2010, 2023):
            begin = pd.Timestamp(year=year, month=month_start, day=1)
            end = pd.Timestamp(year=year+int(month_end/12),
                               month=month_end % 12 + 1, day=1)
            end = end - pd.Timedelta(1, unit='s')
            trange = [begin, end]
            P = self.get_timeseries(tsdicP).get_data(resample={'method': 'sum',
                                                               'scale': '1D'},
                                                     period=trange)
            ETp = self.get_timeseries(tsdicETp).get_data(resample={'method': 'sum',
                                                                   'scale': '1D'},
                                                         period=trange)
            # Pdef_year = (P - ETp).cumsum()
            # Pdef_year = Pdef_year.rolling(window).apply(lambda x: x[-1] - x[0])
            Pdef_year = P - ETp
            Pdef_year = Pdef_year.rolling(window).sum()
            Pdef_year.loc[end] = np.nan
            Pdef = pd.concat([Pdef, Pdef_year])
        tsPdef = Timeseries(name, Pdef)
        self.add_timeseries(tsPdef)
        
        
